#!/usr/bin/python
-import os, stat, time, subprocess, sys
+import os, shutil, stat, time, subprocess, sys
from collections import OrderedDict
+# some utility functions
+def safeCall(*args):
+ res = ""
+ for arg in args:
+ assert arg.find("'") < 0 # ' is not supported
+ if len(res): res += " "
+ res += "'"+arg+"'"
+ return res
+
+# representation of a build system
+class BuildSystem:
+ def __init__(self, ruleMaker, buildDepends = [], binaryDepends = []):
+ self.ruleMaker = ruleMaker
+ self.buildDepends = buildDepends
+ self.binaryDepends = binaryDepends
+
# abstract representation of rules file
class RulesFile:
def __init__(self):
- self.env = []
+ self.env = {}
self.dh = []
+ self.dhWith = set()
self.rules = OrderedDict()
+ def env2str(self):
+ res = ""
+ for name in self.env: # we rely on the name being sane (i.e., no special characters)
+ val = self.env[name]
+ assert val.find("'") < 0 # ' is not supported
+ if len(res): res += " "
+ res += name+"='"+val+"'"
+ return res
+
def write(self, f):
print >>f, "#!/usr/bin/make -f"
print >>f, ""
- print >>f, "%:"
- print >>f, '\t'+' '.join(self.env)+' dh $@',' '.join(self.dh)
+ print >>f, ".PHONY: build" # there may be a directory called "build"
+ print >>f, ""
+ print >>f, "build %:" # need to mention "build" here again explicitly
+ # write proper dh call
+ dh = self.dh
+ if self.dhWith:
+ dh.append('--with='+','.join(self.dhWith))
+ print >>f, '\t'+self.env2str()+' dh $@ '+safeCall(*dh)
+ # write remaining rules
for rule in self.rules:
print >>f, ""
print >>f, "override_dh_"+rule+":"
for line in self.rules[rule]:
print >>f, "\t"+line
-# build-system specific part of rules file
+# rule-makers
def cmakeRules(config):
+ buildDir = config.get('buildDir', 'build')
+ srcDir = os.getcwd()
r = RulesFile()
- r.dh += ["--buildsystem=cmake", "--builddirectory=build.dir"] # dh parameters: "build" is not a good idea, as that's also the name of a target...
+ r.dh += ["--buildsystem=cmake", "--builddirectory="+buildDir] # dh parameters
r.rules['auto_configure'] = [
- 'mkdir -p build.dir',
- "cd build.dir && cmake .. -DCMAKE_INSTALL_PREFIX=/usr "+' '.join(config.get('cmakeParameters', []))
+ safeCall("mkdir", "-p", buildDir),
+ safeCall("cd", buildDir) + " && " +
+ safeCall("cmake", srcDir, "-DCMAKE_INSTALL_PREFIX=/usr", *config.get('cmakeParameters', []))
]
- r.rules['auto_clean'] = ['rm -f build.dir/CMakeCache.txt'] # clean old cmake cache
+ r.rules['auto_clean'] = [safeCall('rm', '-f', os.path.join(buildDir, 'CMakeCache.txt'))] # clean old cmake cache
return r
def automakeRules(config):
+ # "build" is what we are building *on*, and "host" is what we are building *for* (and GNU is weird...)
+ # also, we don't really support cross-building... ;-) (to do, we'd have to write shell code that checks whether BUILD_GNU_TYPE
+ # and HOST_GNU_TYPE are equal, and if they are not, add a --host parameter)
r = RulesFile()
r.dh += ["--buildsystem=autoconf"]
r.rules['auto_configure'] = [
'BUILD_TYPE=$$(dpkg-architecture -qDEB_BUILD_GNU_TYPE) && ' + # doing the expansion beforehand ensures that we cancel if it fails
- 'MULTIARCH=$$(dpkg-architecture -qDEB_BUILD_MULTIARCH) && '+
- './configure --build=$$BUILD_TYPE ' +
- '--prefix=/usr --includedir=/usr/include --mandir=/usr/share/man --infodir=/usr/share/info ' +
+ 'MULTIARCH=$$(dpkg-architecture -qDEB_HOST_MULTIARCH) && '+
+ './configure --build=$$BUILD_TYPE '+ # do the escape manually here so we can use the variables (there's no user-controlled string in here anyway)
+ '--prefix=/usr --includedir=/usr/include --mandir=/usr/share/man --infodir=/usr/share/info '+
'--libdir=/usr/lib/$$MULTIARCH --libexecdir=/usr/lib/$$MULTIARCH '+
- '--sysconfdir=/etc --localstatedir=/var ' +
- ' '.join(config.get('automakeParameters', []))
+ '--sysconfdir=/etc --localstatedir=/var '+
+ safeCall(*config.get('automakeParameters', []))
+ ]
+ r.rules['auto_clean'] = ['rm -f config.status'] # do not re-use old configuration (no need for escaping here, obviously)
+ return r
+
+def pythonRules(config):
+ r = RulesFile()
+ r.dh += ["--buildsystem=python_distutils"]
+ r.dhWith.add('python2')
+ r.rules['auto_clean'] = [ # clean properly
+ 'dh_auto_clean',
+ 'rm -rf build'
]
- r.rules['auto_clean'] = ['rm -f config.status'] # do not re-use old configuration
return r
+# build systems
+buildSystems = {
+ 'cmake': BuildSystem(cmakeRules, ["cmake"]),
+ 'automake': BuildSystem(automakeRules),
+ 'python': BuildSystem(pythonRules, ["python-setuptools"], ["${python:Depends}"]),
+}
+
# utility functions
def commandInBuildEnv(config, command):
schroot = config.get('schroot')
return command
def getArchitecture(config):
- cmd = commandInBuildEnv(config, ['dpkg-architecture', '-qDEB_BUILD_ARCH'])
+ cmd = commandInBuildEnv(config, ['dpkg-architecture', '-qDEB_HOST_ARCH'])
p = subprocess.Popen(cmd, stdout=subprocess.PIPE)
res = p.communicate()[0] # get only stdout
if p.returncode != 0: raise Exception("Querying dpkg for the architecture failed")
def createDebianFiles(config):
sourceName = config['sourceName']
binaryName = config.get('binaryName', sourceName+'-local')
- name = config.get('name', os.getlogin())
- email = config.get('email', os.getlogin()+'@'+os.uname()[1]) # user@hostname
+ name = config.get('name', os.getenv('USER')) # os.getlogin() fails in minimal chroots
+ email = config.get('email', os.getenv('USER')+'@'+os.uname()[1]) # user@hostname
debDir = os.path.expanduser(config['debDir'])
- buildSystem = config['buildSystem']
+ buildSystem = buildSystems[config['buildSystem']] # get the data immediately
version = config['version']
dbgPackage = config.get('dbgPackage', False)
+ parallelJobs = int(config.get('parallelJobs', 2))
packageArchitecture = config.get('architecture', 'any')
+ withPython2 = config.get('withPython2', False)
+ if withPython2:
+ buildSystem.binaryDepends.append("${python:Depends}") # HACK, but it works: make sure dependencies on binary are added
# we return the list of files generated, so we need to know the architecture
arch = getArchitecture(config)
files = []
+ # create folders
+ if os.path.exists('debian'): raise Exception('debian folder already exists?')
+ os.mkdir('debian')
+ os.mkdir('debian/source')
+ if not os.path.exists(debDir): os.makedirs(debDir)
# source format file
- if not os.path.exists('debian/source'): os.mkdir('debian/source')
with open('debian/source/format', 'w') as f:
print >>f, "3.0 (native)"
# compat file
print >>f, "Section:",config.get('section', 'misc')
print >>f, "Priority: extra"
print >>f, "Maintainer: %s <%s>" % (name, email)
- writeDependency(f, 'Build-Depends', ["debhelper (>= 9)"] + config.get('buildDepends', []))
+ writeDependency(f, 'Build-Depends', ["debhelper (>= 9)"] + buildSystem.buildDepends + config.get('buildDepends', []))
print >>f, "Standards-Version: 3.9.3"
print >>f, ""
print >>f, "Package:",binaryName
print >>f, "Architecture:",packageArchitecture
+ if 'binaryMultiArch' in config:
+ print >>f, "Multi-Arch:",config['binaryMultiArch']
writeDependency(f, "Pre-Depends", ["${misc:Pre-Depends}"] + config.get('binaryPreDepends', []))
- writeDependency(f, "Depends", ["${shlibs:Depends}", "${misc:Depends}"] + config.get('binaryDepends', []))
+ writeDependency(f, "Depends", ["${shlibs:Depends}", "${misc:Depends}"] + buildSystem.binaryDepends +
+ config.get('binaryDepends', []))
writeDependency(f, "Recommends", config.get('binaryRecommends', []))
writeDependency(f, "Provides", config.get('binaryProvides', [sourceName]))
+ writeDependency(f, "Conflicts", config.get('binaryConflicts', []))
print >>f, "Description:",sourceName,"(auto-debuild)"
print >>f, " Package auto-generated by auto-debuild."
files.append(os.path.join(debDir, "%s_%s_%s.deb" % (binaryName, version, arch)))
print >>f, "Description:",sourceName,"debug smbols (auto-debuild)"
print >>f, " Package containing debug symbols for "+sourceName+", auto-generated by auto-debuild."
files.append(os.path.join(debDir, "%s-dbg_%s_%s.deb" % (binaryName, version, arch)))
+ # install file
+ with open('debian/'+binaryName+'.install', 'w') as f:
+ for line in config.get('binaryInstallFiles', []):
+ if line.startswith('/'): # a file from within the package, not from the source tree
+ line = 'debian/'+binaryName+line
+ print >>f, line
+ # maintainer scripts for alternatives
+ if 'alternatives' in config:
+ with open('debian/'+binaryName+'.postinst', 'w') as f:
+ print >>f, "#!/bin/sh"
+ print >>f, "set -e"
+ print >>f, 'if [ "$1" = "configure" ]; then'
+ for alternative in config['alternatives']:
+ print >>f, safeCall('update-alternatives', '--install', alternative['link'], alternative['name'], alternative['target'],
+ str(alternative['priority']))
+ print >>f, 'fi'
+ print >>f, ''
+ print >>f, '#DEBHELPER#'
+ print >>f, ''
+ print >>f, 'exit 0'
+ with open('debian/'+binaryName+'.prerm', 'w') as f:
+ print >>f, "#!/bin/sh"
+ print >>f, "set -e"
+ print >>f, 'if [ "$1" = "remove" ]; then'
+ for alternative in config['alternatives']:
+ print >>f, safeCall('update-alternatives', '--remove', alternative['name'], alternative['target'])
+ print >>f, 'fi'
+ print >>f, ''
+ print >>f, '#DEBHELPER#'
+ print >>f, ''
+ print >>f, 'exit 0'
# rules file: build system specific
with open('debian/rules', 'w') as f:
# get rule file for build system: may only touch auto_config and auto_clean rules and the dh options
- if buildSystem == 'cmake':
- r = cmakeRules(config)
- elif buildSystem == 'automake':
- r = automakeRules(config)
- else:
- raise Exception("Invalid build system "+buildSystem)
+ r = buildSystem.ruleMaker(config)
# global rules
- r.env += ["DEB_BUILD_OPTIONS='parallel=2'"]
- if not dbgPackage: r.env += ["DEB_CFLAGS_APPEND='-g0'", "DEB_CXXFLAGS_APPEND='-g0'"] # disable debug information
+ r.env["DEB_BUILD_OPTIONS"] = 'parallel='+str(parallelJobs)
+ if not dbgPackage:
+ # disable debug information
+ r.env["DEB_CFLAGS_APPEND"] = '-g0'
+ r.env["DEB_CXXFLAGS_APPEND"] = '-g0'
r.dh += ['--parallel']
- r.rules['builddeb'] = ['dh_builddeb --destdir='+debDir] # passing this gobally to dh results in weird problems (like stuff being installed there, and not in the package...)
+ if withPython2:
+ r.dhWith.add('python2')
+ r.rules['python2'] = ['dh_python2 --no-guessing-versions']
+ r.rules['builddeb'] = [safeCall('dh_builddeb', "--destdir="+debDir)] # passing this gobally to dh results in weird problems (like stuff being installed there, and not in the package...)
r.rules['auto_test'] = []
- r.rules['auto_install'] = ['dh_auto_install --destdir=debian/'+binaryName] # install everything into the binary package
+ # installation rule
+ r.rules['auto_install'] = [safeCall('dh_auto_install', '--destdir=debian/'+binaryName)] # install everything into the binary package
+ if 'binarySkipFiles' in config:
+ r.rules['auto_install'].append(safeCall('cd', 'debian/'+binaryName) + " && " +
+ safeCall('rm', *config['binarySkipFiles']))
# for debug packages
if dbgPackage:
- r.rules['strip'] = ['dh_strip --dbg-package='+binaryName+"-dbg"] # put debug files in appropriate package
- r.rules['installdocs'] = ['dh_installdocs --link-doc='+binaryName] # make the doc folder of the dbg package a symlink
+ r.rules['strip'] = [safeCall('dh_strip', '--dbg-package='+binaryName+"-dbg")] # put debug files in appropriate package
+ r.rules['installdocs'] = [safeCall('dh_installdocs', '--link-doc='+binaryName)] # make the doc folder of the dbg package a symlink
+ # wait after configuration?
+ if config.get('waitAfterConfig', False):
+ r.rules['auto_configure'].append("@"+safeCall('read', '-p', 'Configuration done. Hit "Enter" to build the package. ', 'DUMMY_VAR')) # if we run in dash, we need to tell it which variable to use for the result...
# dump it to a file
r.write(f)
mode = os.stat('debian/rules').st_mode
os.chmod('debian/rules', mode | stat.S_IXUSR | stat.S_IXGRP | stat.S_IXOTH)
- # return list of files affected
+ # return list of files that will be created
return files
def buildDebianPackage(config):
commands = ['dpkg-checkbuilddeps', 'debian/rules clean', 'debian/rules build', 'fakeroot debian/rules binary', 'debian/rules clean']
- command = ['bash', '-c', ' && '.join(commands)]
+ command = ['bash', '-c', ' && '.join(commands)] # make it all one command, so we don't have to open and close the chroot too often
subprocess.check_call(commandInBuildEnv(config, command))
+ shutil.rmtree('debian') # it only contains what we just created
-# all at once
-def createAndInstall(config, overwriteCheck = False):
- # generate debian files
- files = createDebianFiles(config)
- # check if a file is overwritten
- if overwriteCheck:
+###################################################################
+# if we are called directly as script
+if __name__ == "__main__":
+ try:
+ import imp
+ # get config
+ config = imp.load_source('config', 'auto-debuild.conf').__dict__
+ os.remove('auto-debuild.confc')
+ # generate debian files
+ if os.path.exists('debian'):
+ if raw_input("A debian folder already exists, to you want to remove it (y/N)? ").lower() != "y":
+ sys.exit(1)
+ shutil.rmtree('debian')
+ files = createDebianFiles(config)
+ # check if a file is overwritten
for file in files:
if os.path.exists(file):
if raw_input("Do you want to overwrite %s (y/N)? " % file).lower() != "y":
sys.exit(1)
- # run compilation
- buildDebianPackage(config)
- # install files
- print "Installing created deb files..."
- subprocess.check_call(['sudo', 'dpkg', '--install'] + files)
-
-# if we are called directly as script
-if __name__ == "__main__":
- # get config
- import imp
- config = imp.load_source('config', 'debian/auto-debuild.conf').__dict__
- os.remove('debian/auto-debuild.confc')
- # and go for it
- createAndInstall(config, overwriteCheck=True)
+ # run compilation
+ buildDebianPackage(config)
+ # install files
+ print "Installing created deb files..."
+ subprocess.check_call(['sudo', 'dpkg', '--install'] + files)
+ except (subprocess.CalledProcessError, KeyboardInterrupt) as e: # for some exceptions, a stackrace is usually pointless
+ print >> sys.stderr
+ print >> sys.stderr
+ if isinstance(e, KeyboardInterrupt): # str(e) would be the empty string
+ print >> sys.stderr, "Interruped by user"
+ else:
+ print >> sys.stderr, "Error during package creation: %s" % str(e)
+ print >> sys.stderr
+ sys.exit(1)